.module entradaSalida
	   fin      .equ 0xFF01
	   pantalla .equ 0xFF00
	   teclado  .equ 0xFF02
	   
        .globl imprime_decimal
        .globl imprime_cadena
        .globl leer_decimal
        .globl srand
        .globl rand
        .globl ruido
        .globl formula

        
semilla:   .byte 0             
srand:
	lbsr leer_decimal
	stb semilla
	rts
cont:      .byte 0 
rand:   
	lda semilla
	ldb #1509
	MUL
	addd #41
	tfr b,a
bien:
	cmpa #10
	bhi resta
    sta ,y+      
	lbsr imprime_decimal
	sta semilla
	rts
resta: 
	 suba #11
   	 bra bien
        
        
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; imprime_decimal                                                  ;
;     saca por la pantalla la cifra decimal contenida en A         ;
;                                                                  ;
;   Entrada: A-cifra decimal, del 0 al 255                         ;
;   Salida:  ninguna                                               ;   
;   Registros afectados: A, CC.                                    ;  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

imprime_decimal:
	pshs d
	; primera cifra
        ldb #'0
        cmpa #100
        blo Menor100
        suba #100
        incb
        cmpa #100
        blo Menor200
        incb
        suba #100
Menor100:
Menor200:
        stb pantalla

        ; segunda cifra.  En A quedan las dos Ultimas cifras
        clrb
        cmpa #80
        blo Menor80
        incb
        suba #80
Menor80:lslb
        cmpa #40
        blo Menor40
        incb
        suba #40
Menor40:lslb
        cmpa #20
        blo Menor20
        incb
        suba #20
Menor20:lslb
        cmpa #10
        blo Menor10
        incb
        suba #10
Menor10:addb #'0
        stb pantalla
        adda #'0
        sta pantalla
        
        ldb #' 
        stb pantalla
        puls d,pc
        
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; imprime_cadena                                                   ;
;     saca por la pantalla la cadena acabada en '\0 apuntada por X ;
;                                                                  ;
;   Entrada: X-direcciOn de comienzo de la cadena                  ;
;   Salida:  ninguna                                               ;
;   Registros afectados: X, CC.                                    ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
imprime_cadena:
	pshs a
sgte:   lda ,x+
        beq ret_imprime_cadena
        sta pantalla
        bra sgte
ret_imprime_cadena:
        puls a, pc

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; leer_decimal                                                     ;            
;     lee un numero decimal del tamaño de un byte    ;       
;                                                                  ;
;   Entrada:                         ;
;   Salida: B                                           ;
;   Registros afectados: X, CC.                                    ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

num:      .byte 0 
leer_decimal:
	   ;1ª cifra
		pshs a
		clra
		sta num
		lda teclado
        suba #'0
        ldb #100
        MUL ;lo multiplicas en D pero lo tienes en B porque es menor de 255
        addb num
        stb num
        
        ;2ª cifra
        lda teclado
        suba #'0
        ldb #10
        MUL ;lo multiplicas en D pero lo tienes en B porque es menor de 255
        addb num
        stb num
        
        ;3ª cifra
        ldb teclado
        subb #'0
        addb num   ;solo puedes hacer esto porque tienen que ser de .byte
        stb num
        puls a,pc

numCol:         .byte 0       
numFil:         .byte 0 
formula:        
        stb numCol
		sta numFil
        rts
        
media:      .byte 0 
i:          .byte 0 
j:          .byte 0 
k:          .byte 0 
m:          .byte 0
r:          .byte 0
ini1:       .byte 0
ini2:       .byte 0
vab:        .byte 0
ruido:

	;COMPROBACIONES INICIALES
	sta i
	sta ini1
	cmpa #0
	lbeq noRuido
	stb j
	stb ini2
	cmpb #0
	lbeq noRuido

	 lda ini1
	 deca    ; recorremos desde i-1 j-1 hasta i+1 j+1
	 sta i
	 ldb ini2
	 decb
	 stb j    ;aqui en j y i tenemos j-1 y i-1
	 
	 lda ini1
	 inca 
	 sta k   ;en k tenemos i+1
	 
	 lda ini2
	 inca 
	 sta m    ;en m tenemos j+1

	 clra
	 sta media
	 
	 ;aqui tenemos en i y j (-1) y en k y m (+1)
	 
mediaa: 
	  lda i    ;vale lo que valia i-1
	  ldb numCol
	  incb
	  MUL
	  addb j

	  lda b,y
	  adda media
	  sta media	
	  lda j
	  inca
	  sta j
	  cmpa m
	  lbne anadirj
	  
	  lda i
	  inca
	  sta i
	  cmpa k
	  lbne anadiri
	  
	  lda ini1
	  ldb numCol
	  incb
	  MUL
	  addb ini2

	  lda b,y     ;quitamos el del medio
	  sta vab
	  lda media
	  suba vab
	  sta media
	  lsra
	  lsra
	  lsra   ;ponemos 3 0 por la izquierda para dividir
	  sta media
	  
comparar:  lda vab
	  suba media  ;diferencia de restar media con vab
	  cmpa #0
	  blt cambiarsigno
seguir: cmpa #2
	  blo noRuido 
	  bhs siRuido
	  
anadirj: lda j
	    inca
	    sta j
	    lbra mediaa

anadiri: lda i
         inca
         sta i
         lbra mediaa
		
cambiarsigno: nega
			  inca
			  bra seguir

noRuido:
	  lda #0	   
	  rts
siRuido:	  
	  lda #1
	  rts






